Cgl 0.60.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Groups Pages
Public Member Functions | Protected Attributes | List of all members
OsiChooseVariable Class Reference

This class chooses a variable to branch on. More...

`#include <OsiChooseVariable.hpp>`

Inheritance diagram for OsiChooseVariable:
[legend]
Collaboration diagram for OsiChooseVariable:
[legend]

## Public Member Functions
| OsiChooseVariable ()
| Default Constructor. More...
| OsiChooseVariable (const OsiSolverInterface *solver)
| Constructor from solver (so we can set up arrays etc) More...
| OsiChooseVariable (const OsiChooseVariable &)
| Copy constructor. More...
OsiChooseVariable & | operator= (const OsiChooseVariable &rhs)
| Assignment operator. More...
virtual OsiChooseVariable * | clone () const
| Clone. More...
virtual | ~OsiChooseVariable ()
| Destructor. More...
virtual int | setupList (OsiBranchingInformation *info, bool initialize)
| Sets up strong list and clears all if initialize is true. More...
virtual int | chooseVariable (OsiSolverInterface *solver, OsiBranchingInformation *info, bool fixVariables)
| Choose a variable Returns - -1 Node is infeasible 0 Normal termination - we have a candidate 1 All looks satisfied - no candidate 2 We can change the bound on a variable - but we also have a strong branching candidate 3 We can change the bound on a variable - but we have a non-strong branching candidate 4 We can change the bound on a variable - no other candidates We can pick up branch from bestObjectIndex() and bestWhichWay() We can pick up a forced branch (can change bound) from firstForcedObjectIndex() and firstForcedWhichWay() If we have a solution then we can pick up from goodObjectiveValue() and goodSolution() If fixVariables is true then 2,3,4 are all really same as problem changed. More...
virtual bool | feasibleSolution (const OsiBranchingInformation *info, const double *solution, int numberObjects, const OsiObject **objects)
| Returns true if solution looks feasible against given objects. More...
void | saveSolution (const OsiSolverInterface *solver)
| Saves a good solution. More...
void | clearGoodSolution ()
| Clears out good solution after use. More...
virtual void | updateInformation (const OsiBranchingInformation *info, int branch, OsiHotInfo *hotInfo)
| Given a candidate fill in useful information e.g. estimates. More...
virtual void | updateInformation (int whichObject, int branch, double changeInObjective, double changeInValue, int status)
| Given a branch fill in useful information e.g. estimates. More...
double | goodObjectiveValue () const
| Objective value for feasible solution. More...
double | upChange () const
| Estimate of up change or change on chosen if n-way. More...
double | downChange () const
| Estimate of down change or max change on other possibilities if n-way. More...
const double * | goodSolution () const
| Good solution - deleted by finalize. More...
int | bestObjectIndex () const
| Index of chosen object. More...
void | setBestObjectIndex (int value)
| Set index of chosen object. More...
int | bestWhichWay () const
| Preferred way of chosen object. More...
void | setBestWhichWay (int value)
| Set preferred way of chosen object. More...
int | firstForcedObjectIndex () const
| Index of forced object. More...
void | setFirstForcedObjectIndex (int value)
| Set index of forced object. More...
int | firstForcedWhichWay () const
| Preferred way of forced object. More...
void | setFirstForcedWhichWay (int value)
| Set preferred way of forced object. More...
int | numberUnsatisfied () const
| Get the number of objects unsatisfied at this node - accurate on first pass. More...
int | numberStrong () const
| Number of objects to choose for strong branching. More...
void | setNumberStrong (int value)
| Set number of objects to choose for strong branching. More...
int | numberOnList () const
| Number left on strong list. More...
int | numberStrongDone () const
| Number of strong branches actually done. More...
int | numberStrongIterations () const
| Number of strong iterations actually done. More...
int | numberStrongFixed () const
| Number of strong branches which changed bounds. More...
const int * | candidates () const
| List of candidates. More...
bool | trustStrongForBound () const
| Trust results from strong branching for changing bounds. More...
void | setTrustStrongForBound (bool yesNo)
| Set trust results from strong branching for changing bounds. More...
bool | trustStrongForSolution () const
| Trust results from strong branching for valid solution. More...
void | setTrustStrongForSolution (bool yesNo)
| Set trust results from strong branching for valid solution. More...
void | setSolver (const OsiSolverInterface *solver)
| Set solver and redo arrays. More...
int | status () const
| Return status - -1 Node is infeasible 0 Normal termination - we have a candidate 1 All looks satisfied - no candidate 2 We can change the bound on a variable - but we also have a strong branching candidate 3 We can change the bound on a variable - but we have a non-strong branching candidate 4 We can change the bound on a variable - no other candidates We can pick up branch from bestObjectIndex() and bestWhichWay() We can pick up a forced branch (can change bound) from firstForcedObjectIndex() and firstForcedWhichWay() If we have a solution then we can pick up from goodObjectiveValue() and goodSolution() More...
void | setStatus (int value)

## Protected Attributes
double | goodObjectiveValue_
| Objective value for feasible solution. More...
double | upChange_
| Estimate of up change or change on chosen if n-way. More...
double | downChange_
| Estimate of down change or max change on other possibilities if n-way. More...
double * | goodSolution_
| Good solution - deleted by finalize. More...
int * | list_
| List of candidates. More...
double * | useful_
| Useful array (for sorting etc) More...
const OsiSolverInterface * | solver_
| Pointer to solver. More...
int | status_
int | bestObjectIndex_
| Index of chosen object. More...
int | bestWhichWay_
| Preferred way of chosen object. More...
int | firstForcedObjectIndex_
| Index of forced object. More...
int | firstForcedWhichWay_
| Preferred way of forced object. More...
int | numberUnsatisfied_
| The number of objects unsatisfied at this node. More...
int | numberStrong_
| Number of objects to choose for strong branching. More...
int | numberOnList_
| Number left on strong list. More...
int | numberStrongDone_
| Number of strong branches actually done. More...
int | numberStrongIterations_
| Number of strong iterations actually done. More...
int | numberStrongFixed_
| Number of bound changes due to strong branching. More...
bool | trustStrongForBound_
| List of unsatisfied objects - first numberOnList_ for strong branching Trust results from strong branching for changing bounds. More...
bool | trustStrongForSolution_
| Trust results from strong branching for valid solution. More...

## Detailed Description

This class chooses a variable to branch on.

The base class just chooses the variable and direction without strong branching but it has information which would normally be used by strong branching e.g. to re-enter having fixed a variable but using same candidates for strong branching.

The flow is : a) initialize the process. This decides on strong branching list and stores indices of all infeasible objects b) do strong branching on list. If list is empty then just choose one candidate and return without strong branching. If not empty then go through list and return best. However we may find that the node is infeasible or that we can fix a variable. If so we return and it is up to user to call again (after fixing a variable).

Definition at line 33 of file OsiChooseVariable.hpp.

## Constructor & Destructor Documentation

OsiChooseVariable::OsiChooseVariable | ( |  | ) |

Default Constructor.

OsiChooseVariable::OsiChooseVariable | ( | const OsiSolverInterface * | solver | ) |

Constructor from solver (so we can set up arrays etc)

OsiChooseVariable::OsiChooseVariable | ( | const OsiChooseVariable & |  | ) |

Copy constructor.

virtual OsiChooseVariable::~OsiChooseVariable | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

OsiChooseVariable& OsiChooseVariable::operator= | ( | const OsiChooseVariable & | rhs | ) |

Assignment operator.

virtual OsiChooseVariable* OsiChooseVariable::clone | ( |  | ) | const
| virtual

Clone.

Reimplemented in OsiChooseStrong.

virtual int OsiChooseVariable::setupList | ( | OsiBranchingInformation * | info,
|  | bool | initialize
| ) |  |
| virtual

Sets up strong list and clears all if initialize is true.

Returns number of infeasibilities. If returns -1 then has worked out node is infeasible!

Reimplemented in OsiChooseStrong.

virtual int OsiChooseVariable::chooseVariable | ( | OsiSolverInterface * | solver,
|  | OsiBranchingInformation * | info,
|  | bool | fixVariables
| ) |  |
| virtual

Choose a variable Returns - -1 Node is infeasible 0 Normal termination - we have a candidate 1 All looks satisfied - no candidate 2 We can change the bound on a variable - but we also have a strong branching candidate 3 We can change the bound on a variable - but we have a non-strong branching candidate 4 We can change the bound on a variable - no other candidates We can pick up branch from bestObjectIndex() and bestWhichWay() We can pick up a forced branch (can change bound) from firstForcedObjectIndex() and firstForcedWhichWay() If we have a solution then we can pick up from goodObjectiveValue() and goodSolution() If fixVariables is true then 2,3,4 are all really same as problem changed.

Reimplemented in OsiChooseStrong.

virtual bool OsiChooseVariable::feasibleSolution | ( | const OsiBranchingInformation * | info,
|  | const double * | solution,
|  | int | numberObjects,
|  | const OsiObject ** | objects
| ) |  |
| virtual

Returns true if solution looks feasible against given objects.

void OsiChooseVariable::saveSolution | ( | const OsiSolverInterface * | solver | ) |

Saves a good solution.

void OsiChooseVariable::clearGoodSolution | ( |  | ) |

Clears out good solution after use.

virtual void OsiChooseVariable::updateInformation | ( | const OsiBranchingInformation * | info,
|  | int | branch,
|  | OsiHotInfo * | hotInfo
| ) |  |
| virtual

Given a candidate fill in useful information e.g. estimates.

virtual void OsiChooseVariable::updateInformation | ( | int | whichObject,
|  | int | branch,
|  | double | changeInObjective,
|  | double | changeInValue,
|  | int | status
| ) |  |
| virtual

Given a branch fill in useful information e.g. estimates.

double OsiChooseVariable::goodObjectiveValue | ( |  | ) | const
| inline

Objective value for feasible solution.

Definition at line 92 of file OsiChooseVariable.hpp.

double OsiChooseVariable::upChange | ( |  | ) | const
| inline

Estimate of up change or change on chosen if n-way.

Definition at line 97 of file OsiChooseVariable.hpp.

double OsiChooseVariable::downChange | ( |  | ) | const
| inline

Estimate of down change or max change on other possibilities if n-way.

Definition at line 102 of file OsiChooseVariable.hpp.

const double* OsiChooseVariable::goodSolution | ( |  | ) | const
| inline

Good solution - deleted by finalize.

Definition at line 107 of file OsiChooseVariable.hpp.

int OsiChooseVariable::bestObjectIndex | ( |  | ) | const
| inline

Index of chosen object.

Definition at line 112 of file OsiChooseVariable.hpp.

void OsiChooseVariable::setBestObjectIndex | ( | int | value | ) |
| inline

Set index of chosen object.

Definition at line 117 of file OsiChooseVariable.hpp.

int OsiChooseVariable::bestWhichWay | ( |  | ) | const
| inline

Preferred way of chosen object.

Definition at line 122 of file OsiChooseVariable.hpp.

void OsiChooseVariable::setBestWhichWay | ( | int | value | ) |
| inline

Set preferred way of chosen object.

Definition at line 127 of file OsiChooseVariable.hpp.

int OsiChooseVariable::firstForcedObjectIndex | ( |  | ) | const
| inline

Index of forced object.

Definition at line 132 of file OsiChooseVariable.hpp.

void OsiChooseVariable::setFirstForcedObjectIndex | ( | int | value | ) |
| inline

Set index of forced object.

Definition at line 137 of file OsiChooseVariable.hpp.

int OsiChooseVariable::firstForcedWhichWay | ( |  | ) | const
| inline

Preferred way of forced object.

Definition at line 142 of file OsiChooseVariable.hpp.

void OsiChooseVariable::setFirstForcedWhichWay | ( | int | value | ) |
| inline

Set preferred way of forced object.

Definition at line 147 of file OsiChooseVariable.hpp.

int OsiChooseVariable::numberUnsatisfied | ( |  | ) | const
| inline

Get the number of objects unsatisfied at this node - accurate on first pass.

Definition at line 152 of file OsiChooseVariable.hpp.

int OsiChooseVariable::numberStrong | ( |  | ) | const
| inline

Number of objects to choose for strong branching.

Definition at line 157 of file OsiChooseVariable.hpp.

void OsiChooseVariable::setNumberStrong | ( | int | value | ) |
| inline

Set number of objects to choose for strong branching.

Definition at line 162 of file OsiChooseVariable.hpp.

int OsiChooseVariable::numberOnList | ( |  | ) | const
| inline

Number left on strong list.

Definition at line 167 of file OsiChooseVariable.hpp.

int OsiChooseVariable::numberStrongDone | ( |  | ) | const
| inline

Number of strong branches actually done.

Definition at line 172 of file OsiChooseVariable.hpp.

int OsiChooseVariable::numberStrongIterations | ( |  | ) | const
| inline

Number of strong iterations actually done.

Definition at line 177 of file OsiChooseVariable.hpp.

int OsiChooseVariable::numberStrongFixed | ( |  | ) | const
| inline

Number of strong branches which changed bounds.

Definition at line 182 of file OsiChooseVariable.hpp.

const int* OsiChooseVariable::candidates | ( |  | ) | const
| inline

List of candidates.

Definition at line 187 of file OsiChooseVariable.hpp.

bool OsiChooseVariable::trustStrongForBound | ( |  | ) | const
| inline

Trust results from strong branching for changing bounds.

Definition at line 192 of file OsiChooseVariable.hpp.

void OsiChooseVariable::setTrustStrongForBound | ( | bool | yesNo | ) |
| inline

Set trust results from strong branching for changing bounds.

Definition at line 197 of file OsiChooseVariable.hpp.

bool OsiChooseVariable::trustStrongForSolution | ( |  | ) | const
| inline

Trust results from strong branching for valid solution.

Definition at line 202 of file OsiChooseVariable.hpp.

void OsiChooseVariable::setTrustStrongForSolution | ( | bool | yesNo | ) |
| inline

Set trust results from strong branching for valid solution.

Definition at line 207 of file OsiChooseVariable.hpp.

void OsiChooseVariable::setSolver | ( | const OsiSolverInterface * | solver | ) |

Set solver and redo arrays.

int OsiChooseVariable::status | ( |  | ) | const
| inline

Return status - -1 Node is infeasible 0 Normal termination - we have a candidate 1 All looks satisfied - no candidate 2 We can change the bound on a variable - but we also have a strong branching candidate 3 We can change the bound on a variable - but we have a non-strong branching candidate 4 We can change the bound on a variable - no other candidates We can pick up branch from bestObjectIndex() and bestWhichWay() We can pick up a forced branch (can change bound) from firstForcedObjectIndex() and firstForcedWhichWay() If we have a solution then we can pick up from goodObjectiveValue() and goodSolution()

Definition at line 224 of file OsiChooseVariable.hpp.

void OsiChooseVariable::setStatus | ( | int | value | ) |
| inline

Definition at line 228 of file OsiChooseVariable.hpp.

## Member Data Documentation

double OsiChooseVariable::goodObjectiveValue_
| protected

Objective value for feasible solution.

Definition at line 236 of file OsiChooseVariable.hpp.

double OsiChooseVariable::upChange_
| protected

Estimate of up change or change on chosen if n-way.

Definition at line 238 of file OsiChooseVariable.hpp.

double OsiChooseVariable::downChange_
| protected

Estimate of down change or max change on other possibilities if n-way.

Definition at line 240 of file OsiChooseVariable.hpp.

double* OsiChooseVariable::goodSolution_
| protected

Good solution - deleted by finalize.

Definition at line 242 of file OsiChooseVariable.hpp.

int* OsiChooseVariable::list_
| protected

List of candidates.

Definition at line 244 of file OsiChooseVariable.hpp.

double* OsiChooseVariable::useful_
| protected

Useful array (for sorting etc)

Definition at line 246 of file OsiChooseVariable.hpp.

const OsiSolverInterface* OsiChooseVariable::solver_
| protected

Pointer to solver.

Definition at line 248 of file OsiChooseVariable.hpp.

int OsiChooseVariable::status_
| protected

Definition at line 257 of file OsiChooseVariable.hpp.

int OsiChooseVariable::bestObjectIndex_
| protected

Index of chosen object.

Definition at line 259 of file OsiChooseVariable.hpp.

int OsiChooseVariable::bestWhichWay_
| protected

Preferred way of chosen object.

Definition at line 261 of file OsiChooseVariable.hpp.

int OsiChooseVariable::firstForcedObjectIndex_
| protected

Index of forced object.

Definition at line 263 of file OsiChooseVariable.hpp.

int OsiChooseVariable::firstForcedWhichWay_
| protected

Preferred way of forced object.

Definition at line 265 of file OsiChooseVariable.hpp.

int OsiChooseVariable::numberUnsatisfied_
| protected

The number of objects unsatisfied at this node.

Definition at line 267 of file OsiChooseVariable.hpp.

int OsiChooseVariable::numberStrong_
| protected

Number of objects to choose for strong branching.

Definition at line 269 of file OsiChooseVariable.hpp.

int OsiChooseVariable::numberOnList_
| protected

Number left on strong list.

Definition at line 271 of file OsiChooseVariable.hpp.

int OsiChooseVariable::numberStrongDone_
| protected

Number of strong branches actually done.

Definition at line 273 of file OsiChooseVariable.hpp.

int OsiChooseVariable::numberStrongIterations_
| protected

Number of strong iterations actually done.

Definition at line 275 of file OsiChooseVariable.hpp.

int OsiChooseVariable::numberStrongFixed_
| protected

Number of bound changes due to strong branching.

Definition at line 277 of file OsiChooseVariable.hpp.

bool OsiChooseVariable::trustStrongForBound_
| protected

List of unsatisfied objects - first numberOnList_ for strong branching Trust results from strong branching for changing bounds.

Definition at line 280 of file OsiChooseVariable.hpp.

bool OsiChooseVariable::trustStrongForSolution_
| protected

Trust results from strong branching for valid solution.

Definition at line 282 of file OsiChooseVariable.hpp.

The documentation for this class was generated from the following file:

- /tmp/Cgl-0.60.2/Osi/src/Osi/OsiChooseVariable.hpp